<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="id"
          :columns="columns"
          :datasource="datasource"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'domain'">
              <a
                v-if="record.status == 1"
                class="ele-text-success"
                @click="openPreview(`http://${record.domain}`)"
                >{{ record.domain }}</a
              >
              <span v-else>
                <a-space>
                  {{ record.domain }}
                  <a @click="openEdit(record)">查看验证</a>
                </a-space>
              </span>
            </template>
            <template v-if="column.key === 'hostName'">
              <span class="ele-text-placeholder">{{ record.hostName }}</span>
            </template>
            <template v-if="column.key === 'hostType'">
              <span class="ele-text-placeholder">CNAME</span>
            </template>
            <template v-if="column.key === 'hostValue'">
              <span class="ele-text-placeholder">{{ record.hostValue }}</span>
            </template>
            <template v-if="column.key === 'photo'">
              <a-image :src="record.photo" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag
                v-if="record.status === 0"
                color="orange"
                style="cursor: pointer"
                @click="openEdit(record)"
                >验证中</a-tag
              >
              <a-tag v-if="record.status === 1" color="green">绑定成功</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a-button @click="openEdit(record)" size="small">管理</a-button>
                <a-popconfirm
                  title="确定要删除此域名吗？"
                  :disabled="record.home == 1"
                  @confirm="remove(record)"
                >
                  <a-button size="small">删除</a-button>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <DomainEdit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import DomainEdit from './components/domain-edit.vue';
  import {
    pageDomain,
    removeDomain,
    removeBatchDomain,
    updateDomain
  } from '@/api/cms/domain';
  import type { Domain, DomainParam } from '@/api/cms/domain/model';
  import { openPreview } from '@/utils/common';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Domain[]>([]);
  // 当前编辑数据
  const current = ref<Domain | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageDomain({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '域名',
      dataIndex: 'domain',
      width: 240,
      key: 'domain'
    },
    {
      title: '主机记录',
      dataIndex: 'hostName',
      align: 'center',
      key: 'hostName'
    },
    {
      title: '主机类型',
      dataIndex: 'hostType',
      align: 'center',
      key: 'hostType'
    },
    {
      title: '主机记录值',
      dataIndex: 'hostValue',
      align: 'center',
      key: 'hostValue'
    },
    {
      title: '状态',
      dataIndex: 'status',
      width: 120,
      align: 'center',
      key: 'status'
    },
    {
      title: '操作',
      key: 'action',
      width: 120,
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: DomainParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Domain) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: Domain) => {
    const hide = message.loading('请求中..', 0);
    removeDomain(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchDomain(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };
</script>
<script lang="ts">
  export default {
    name: 'Domain'
  };
</script>
